def solve_for_sub(arr):
    n = len(arr)
    subarrays_len = []
    subarray_len = 1
    i = 1
    increasing = True
    while i < n:
        if bool(arr[i] > arr[i-1]) != increasing:
            subarrays_len.append(subarray_len)
            increasing = not increasing
            subarray_len = 1
            continue # Не увеличиваем i
        subarray_len += 1
        i += 1
    subarrays_len.append(subarray_len)
    result = 0
    for i in subarrays_len:
        result += i*(i+1) // 2
    for i in range(0, len(subarrays_len)-1, 2):
        result += subarrays_len[i] * subarrays_len[i+1]
        result -= subarrays_len[i]
        result -= subarrays_len[i+1]
    return result
def is_bitonic(arr):
    if len(arr) < 4:
        return True
    swaps = 1
    increasing = True
    n = len(arr)
    i = 1
    while i < n:
        if bool(arr[i] > arr[i-1]) != increasing:
            increasing = not increasing
            swaps += 1
        i += 1
    return swaps <= 2

def bruteforce(arr):
    n = len(arr)
    result = 0
    for l in range(n):
        for r in range(l, n):
            result += is_bitonic(arr[l:r+1])
    return result
n = int(input())
arr = list(map(int, input().split()))
subarrays = []
i = 1
subarray = [arr[0]]

while i < n:
    if arr[i] == arr[i-1]:
        subarrays.append(subarray)
        subarray = []
    subarray.append(arr[i])
    i += 1
subarrays.append(subarray)
result = 0
for i in subarrays:
    result += solve_for_sub(i)
print(result)