﻿// ConsoleApplication2.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <unordered_map>
using namespace std;
vector<int64_t> cols;
vector<int> col_ans;
int64_t s;

bool solve(){
	unordered_map<int64_t, int> dp;
	int64_t col_sum = 0;
	dp[0] = -1;
	for (int i = 0; i < cols.size(); i++) {
		col_sum += cols[i];
		vector<int64_t> added;
		added.reserve(dp.size());
		for (const auto& it : dp) {
			added.push_back(it.first + cols[i]);
		}
		for (auto j : added)
			if (!dp.count(j))
				dp[j] = i;
	}
	if (!dp.count(col_sum-s))
		return false;
	auto sum = col_sum-s;
	while (sum) {
		col_ans.push_back(dp[sum]);
		sum -= cols[dp[sum]];
	}
	return true;
}
int main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int h, w;
	cin >> h >> w;
	vector<int64_t> init_cols(w, 0);
	vector<vector<int>> table(h, vector<int>(w));
	for (auto& row : table)
		for (int i = 0; i < w; i++) {
			cin >> row[i];
			init_cols[i] += row[i];
		}
	cin >> s;
	int i;
	bool success = false;
	for (i = 0; i < (1 << h); i++)
	{
		cols = init_cols;
		int ti = i;
		int j = 0;
		while (ti) {
			if (ti & 1) {
				for (int k = 0; k < w; k++)
				{
					cols[k] -= table[j][k];
				}
			}
			ti >>= 1;
			j++;
		}
		if (solve()) {
			success = true;
			break;
		}
	}
	if (!success) {
		cout << "NO\n";
		return 0;
	}
	cout << "YES\n";
	int k = col_ans.size();
	int j = 0;
	int ti = i;
	while (ti)
	{
		if (ti & 1)
			k++;
		ti >>= 1;
	}
	cout << k << '\n';
	while (i) {
		if (i & 1)
			cout << "1 " << j + 1 << '\n';

		i >>= 1;
		j++;
	}
	for (auto k : col_ans)
		cout << "2 " << k + 1 << '\n';
	return 0;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
