﻿// 2tur.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//
#include <iostream>
#include <vector>
#include <algorithm>
#include <bit>
using namespace std;
const int mod = 1'000'000'007;
vector<int> cnt;
long long recursion(int next = 0) {
    if (next >= cnt.size()-2)
        return 1;
    int lim = min({ cnt[next], cnt[next + 1], cnt[next + 2]});
    long long result = 0;
    for (int i = 0; i <= lim; i++, cnt[next]--, cnt[next+1]--, cnt[next+2]--){
        result = (result + recursion(next + 1)) % mod;
    }
    return result;
}
int main()
{
    int n, m;
    cin >> n >> m;
    vector<int> arr(n);
    cnt.assign(m + 1, 0);
    for (auto& i : arr) {
        cin >> i;
        cnt[i]++;
    }
    for (int i = 0; i < m - 1; i++)
    {
        if (cnt[i] < 0) {
            cout << 0 << '\n';
            return 0;
        }
        for (int j = cnt[i] % 3; j > 0; j--) {
            cnt[i]--;
            cnt[i + 1]--;
            cnt[i + 2]--;
        }
    }
    for (auto& i : cnt) {
        if (i % 3 || i < 0) {
            cout << "0\n";
            return 0;
        }
        i /= 3;
    }
    cout << recursion() << '\n';
}