﻿// 2tur.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
using namespace std;
constexpr int max_a = 1e6;
int least_prime[max_a + 1];
int prime_count[max_a + 1];
vector<int> primes;
void compute_primes(){
    for (int i = 2; i <= max_a; i++) {
        if (least_prime[i] == 0) {
            least_prime[i] = i;
            primes.push_back(i);
            prime_count[i] = 1;
        }
        for (auto p : primes) {
            int next = i * p;
            if (next > max_a)
                break;
            least_prime[next] = p;
            prime_count[next] = prime_count[i] + 1;
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    compute_primes();
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int a;
        cin >> a;
        cout << prime_count[a] % 2 + 1 << ' ';
    }
    cout << '\n';
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
