﻿// 2tur.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//
#include <iostream>
#include <vector>
#include <algorithm>
#include <bit>
#include <unordered_map>
#include <map>
using namespace std;
const int mod = 1'000'000'007;
vector<int> cnt;
map<pair<pair<int, int>, int>, int> dp;
long long recursion(int next, int end) {
    if (next >= end-2)
        return 1;
    pair<pair<int, int>, int> dp_key = { {cnt[next], cnt[next + 1]}, next };
    if (dp.contains(dp_key))
        return dp[dp_key];
    int lim = min({ cnt[next], cnt[next + 1], cnt[next + 2]});
    long long result = 0;
    for (int i = 0; i <= lim; i++, cnt[next]--, cnt[next+1]--, cnt[next+2]--){
        result = (result + recursion(next + 1, end)) % mod;
    }
    cnt[next] += lim+1;
    cnt[next + 1] += lim + 1;
    cnt[next + 2] += lim + 1;
    return dp[dp_key] = result;
}
int main()
{
    int n, m;
    cin >> n >> m;
    vector<int> arr(n);
    cnt.assign(m + 1, 0);
    for (auto& i : arr) {
        cin >> i;
        cnt[i]++;
    }
    for (int i = 0; i < m - 1; i++)
    {
        if (cnt[i] < 0) {
            cout << 0 << '\n';
            return 0;
        }
        for (int j = cnt[i] % 3; j > 0; j--) {
            cnt[i]--;
            cnt[i + 1]--;
            cnt[i + 2]--;
        }
    }
    for (auto& i : cnt) {
        if (i % 3 || i < 0) {
            cout << "0\n";
            return 0;
        }
        i /= 3;
    }
    long long result = 1;
    int old_zero = -1;
    cnt.push_back(0);
    for (int i = 0; i <= m+1; i++) {
        if (cnt[i] == 0) {
            result = result * recursion(old_zero + 1, i) % mod;
            old_zero = i;
        }
    }
    cout << result << '\n';
}