﻿// 2tur.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//
#include <iostream>
#include <vector>
#include <algorithm>
#include <bit>
using namespace std;
const int mod = (int)1e9 + 7;
int main()
{
    int n, m;
    cin >> n >> m;
    vector<int> arr(n), cnt(m + 1, 0);
    for (auto& i : arr) {
        cin >> i;
        cnt[i]++;
    }
    for (int i = 0; i < m - 1; i++)
    {
        if (cnt[i] < 0) {
            cout << 0 << '\n';
            return 0;
        }
        for (int j = cnt[i] % 3; j > 0; j--) {
            cnt[i]--;
            cnt[i + 1]--;
            cnt[i + 2]--;
        }
    }
    bool try_3subgroup = true;
    for (auto& i : cnt) {
        if (i % 3 || i < 0) {
            cout << "0\n";
            return 0;
        }
        i /= 3;
    }
    for (int i = 0; i <= m; i += 4) {
        if (cnt[i])
            try_3subgroup = false;
    }
    if (try_3subgroup) {
        long long result = 1;
        while (cnt.size() % 4)
            cnt.push_back(0);
        for (int i = 4; i <= cnt.size(); i += 4) {
            result *= min({ cnt[i - 1], cnt[i - 2], cnt[i - 3] }) + 1;
            result %= mod;
        }
        cout << result << '\n';
        return;
    }
    cout << min({ cnt[1], cnt[2], cnt[3] }) + 1 << '\n';
}